
%**************************************************************************
% Programm cv_demo_main
%
% Author:              Gerhard Schmidt, CAU Digital Signal Processing and
%                      System Theory
% Date of generation:  December, 26, 2005
% Project:             predictor_demo
%
% 
% Input: 
%
% Output:               ---
%
%**************************************************************************


%******************************************************************
% Set path to subdirectories
%******************************************************************
 
addpath([pwd,'/subfunctions']);
addpath([pwd,'/images']);

%******************************************************************
% Main data_struct
%******************************************************************

dim.main_fig.orig_x                        =   12;
dim.main_fig.orig_y                        =   45;
dim.main_fig.width                         = 1000;
dim.main_fig.height                        =  670;
dim.main_fig.space_lr                      =   30; 
dim.main_fig.space_tb                      =   30;
dim.main_fig.af_logo.width                 =  342;
dim.main_fig.af_logo.height                =   48;
dim.main_fig.low_frame.height              =   48;
dim.main_fig.low_frame.button.width        =  140;
dim.main_fig.low_frame.button.height       =   32;
dim.main_fig.low_frame.button.delta_w      =   30;
dim.main_fig.low_frame.checkbox.width      =  100;
dim.main_fig.left_frame.width.small        =  200;
dim.main_fig.left_frame.width.large        =  700;
dim.main_fig.left_frame.space_lr           =   10;
dim.main_fig.left_frame.space_lr_sm        =   10;
dim.main_fig.left_frame.space_tb           =   10;
dim.main_fig.left_frame.space_tb_sm        =    2;
dim.main_fig.left_frame.button.height      =   25;
dim.main_fig.left_frame.button.text_offset =    4;
dim.main_fig.axes.space_left               =   60;
dim.main_fig.axes.space_bottom             =   30;
dim.main_fig.axes.space_delta              =   16;

fonts.normal.size      =  9;
fonts.upper_frame.size = 12;
fonts.small.size       =  9;

main_data.signals.SNR_dB       = 40;
main_data.signals.x            = randn(2000,1); 
main_data.signals.n            = randn(2000,1); 
main_data.signals.cor_coeff_x  = 0.0;
main_data.signals.cor_coeff_n  = 0.0;
main_data.signals.x            = filter(1,[1 -main_data.signals.cor_coeff_x],main_data.signals.x);
main_data.signals.n            = filter(1,[1 -main_data.signals.cor_coeff_n],main_data.signals.n);
main_data.signals.n            = main_data.signals.n / (std(main_data.signals.n)+eps) * std(main_data.signals.x) * 10^(-main_data.signals.SNR_dB/20);
main_data.signals.N            = 2;
main_data.common.x_vec         = zeros(1,main_data.signals.N);
main_data.common.h_opt         = zeros(1,main_data.signals.N)+2;
main_data.common.h_opt(1)      = 4;
main_data.common.y             = 0;
main_data.common.k_sim         = 1;
main_data.cv(1).mu             = 0.3;
main_data.cv(1).h_hat          = zeros(1,main_data.signals.N);
main_data.cv(1).h_hat_old      = zeros(1,main_data.signals.N);
main_data.cv(1).e              = 0;
main_data.cv(2).mu             = 1.0;
main_data.cv(2).h_hat          = zeros(1,main_data.signals.N);
main_data.cv(2).h_hat_old      = zeros(1,main_data.signals.N);
main_data.cv(2).e              = 0;
main_data.cv(3).mu             = 1.7;
main_data.cv(3).h_hat          = zeros(1,main_data.signals.N);
main_data.cv(3).h_hat_old      = zeros(1,main_data.signals.N);
main_data.cv(3).e              = 0;
main_data.cv(4).mu             = 2.05;
main_data.cv(4).h_hat          = zeros(1,main_data.signals.N);
main_data.cv(4).h_hat_old      = zeros(1,main_data.signals.N);
main_data.cv(4).e              = 0;

main_data.plot_mode            = '2D';
main_data.axes(1).handle_h_hat = 0;
main_data.axes(1).handle_h_opt = 0;
main_data.axes(1).handle_h_dif = 0;
main_data.axes(2).handle_h_hat = 0;
main_data.axes(2).handle_h_opt = 0;
main_data.axes(2).handle_h_dif = 0;
main_data.axes(3).handle_h_hat = 0;
main_data.axes(3).handle_h_opt = 0;
main_data.axes(3).handle_h_dif = 0;
main_data.axes(4).handle_h_hat = 0;
main_data.axes(4).handle_h_opt = 0;
main_data.axes(4).handle_h_dif = 0;

main_data.sim_active = 0;
main_data.auto_mode  = 1;

%******************************************************************
% User interface
%******************************************************************

load cv_demo_main;

a = figure('Units','pixels', ...
           'Color',[0.85 0.85 0.85], ...
           'Colormap',mat0, ...
           'Name','Adaptive Filters - Demo Convergence Speed', ...         
	       'NumberTitle','off', ...
           'PointerShapeCData',mat1, ...
	       'Position',[dim.main_fig.orig_x dim.main_fig.orig_y dim.main_fig.width dim.main_fig.height], ...
           'UserData',main_data, ...
           'Tag','demo_cv_main_fig');                  
      
%******************************************************************
% Title frame
%******************************************************************       
          
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ... 
         'CreateFcn','image(logo_adaptive_filters); axis tight; set(gca,''XTick'',[],''YTick'',[]);', ...
	     'Position',[dim.main_fig.space_lr dim.main_fig.height-dim.main_fig.space_tb-dim.main_fig.af_logo.height dim.main_fig.af_logo.width dim.main_fig.af_logo.height], ...
	     'Tag','demo_cv_axes_logo_1');

b = uicontrol('Parent',a, ...                       
	          'Units','pixels', ...                   
	          'BackgroundColor',[0.9 0.9 0.9], ...   
              'Position',[dim.main_fig.af_logo.width+(2*dim.main_fig.space_lr) dim.main_fig.height-dim.main_fig.space_tb-dim.main_fig.af_logo.height dim.main_fig.width-(3*dim.main_fig.space_lr)-dim.main_fig.af_logo.width dim.main_fig.af_logo.height], ...
	          'Style','frame', ...
              'Tag','demo_cv_uppper_fraime'); 
                                                      
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.9 0.9 0.9], ...   
	          'HorizontalAlignment','center', ...
              'FontWeight','bold', ...
              'FontSize',fonts.upper_frame.size, ...
	          'Position',[dim.main_fig.af_logo.width+(2*dim.main_fig.space_lr)+5 dim.main_fig.height-dim.main_fig.space_tb-dim.main_fig.af_logo.height+12 dim.main_fig.width-(3*dim.main_fig.space_lr)-dim.main_fig.af_logo.width-10 20], ...
	          'String','Demo - Convergence Speed', ...
	          'Style','text');  
                   
%******************************************************************
% Left frame (visible)
%******************************************************************    
                        
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
	          'BackgroundColor',[0.9 0.9 0.9], ...   
              'Position',[dim.main_fig.space_lr (2*dim.main_fig.space_tb)+dim.main_fig.af_logo.height dim.main_fig.left_frame.width.small dim.main_fig.height-(4*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-dim.main_fig.low_frame.height ], ...
	          'Style','frame', ...
              'Tag','demo_cv_main_left_frame');           
                    
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
              'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-dim.main_fig.left_frame.space_tb-dim.main_fig.left_frame.button.height round((dim.main_fig.left_frame.width.small-(3*dim.main_fig.left_frame.space_lr))/2) dim.main_fig.left_frame.button.height], ...  
              'Callback','', ...             
	          'String','<<', ...
              'TooltipString','Hides a picture that shows the structure of the algorithm.',...
              'FontWeight','bold', ...   
              'Tag','demo_cv_reduce_left_frame');

b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
              'Position',[dim.main_fig.space_lr+round((dim.main_fig.left_frame.width.small+dim.main_fig.left_frame.space_lr)/2) dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-dim.main_fig.left_frame.space_tb-dim.main_fig.left_frame.button.height round((dim.main_fig.left_frame.width.small-(3*dim.main_fig.left_frame.space_lr))/2) dim.main_fig.left_frame.button.height], ...  
              'Callback','', ...             
	          'String','>>', ...
              'TooltipString','Shows a picture that depicts the structure of the algorithm.',...
              'FontWeight','bold', ...   
              'Tag','demo_cv_enlarge_left_frame');          

b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
	          'BackgroundColor',[0.95 0.95 0.95], ...   
              'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(4*dim.main_fig.left_frame.space_tb)-(5*dim.main_fig.left_frame.button.height) dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr) (4*dim.main_fig.left_frame.button.height)+(3*dim.main_fig.left_frame.space_tb_sm)+dim.main_fig.left_frame.space_tb], ...
	          'Style','frame', ...
              'Tag','demo_predictor_main_left_frame_visualizations');            
              
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.normal.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(3*dim.main_fig.left_frame.space_tb)-(2*dim.main_fig.left_frame.button.height) dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Signals:', ...
	          'Tag','demo_cv_main_left_frame_text_visualization', ...
              'Style','text');            
                           
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(3*dim.main_fig.left_frame.space_tb)-(3*dim.main_fig.left_frame.button.height)-(2*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Excitation:', ...
	          'Tag','demo_cv_main_left_frame_text_signals_excitation_left', ...
              'Style','text');
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)  dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(3*dim.main_fig.left_frame.space_tb)-(3*dim.main_fig.left_frame.button.height)-(2*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','white noise', ...
	          'Tag','demo_cv_main_left_frame_text_signals_excitation_right', ...
              'Style','text');       
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(3*dim.main_fig.left_frame.space_tb)-(4*dim.main_fig.left_frame.button.height)-(2*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Noise:', ...
	          'Tag','demo_cv_main_left_frame_text_signals_noise_left', ...
              'Style','text');
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)  dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(3*dim.main_fig.left_frame.space_tb)-(4*dim.main_fig.left_frame.button.height)-(2*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','white noise', ...
	          'Tag','demo_cv_main_left_frame_text_signals_noise_right', ...
              'Style','text');              

b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(3*dim.main_fig.left_frame.space_tb)-(5*dim.main_fig.left_frame.button.height)-(2*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','SNR (dB):', ...
	          'Tag','demo_cv_main_left_frame_text_signals_excitation_left', ...
              'Style','text');
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)+5  dim.main_fig.height-(2*dim.main_fig.space_tb)-dim.main_fig.af_logo.height-(3*dim.main_fig.left_frame.space_tb)-(5*dim.main_fig.left_frame.button.height)-(2*dim.main_fig.left_frame.space_tb_sm) round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2.1) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.signals.SNR_dB), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.signals.SNR_dB  = str2num(get(gco,''String''));set(gcf,''UserData'',main_data); cv_reset; ', ...
	          'TooltipString','Sets the order of the filters',...
              'Tag','demo_cv_main_left_frame_edit_para_order_right', ...
              'Style','edit');           
          
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
	          'BackgroundColor',[0.95 0.95 0.95], ...   
              'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr  320  dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr) 65], ...
	          'Style','frame', ...
              'Tag','demo_predictor_main_left_frame_order');   
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.normal.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm 355 dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Filter parameters:', ...
	          'Tag','demo_cv_main_left_frame_text_control_parameters', ...
              'Style','text');            
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm 330 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Order:', ...
	          'Tag','demo_cv_main_left_frame_text_para_order_left', ...
              'Style','text');    
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)+5  330 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2.1) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.signals.N), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.signals.N  = str2num(get(gco,''String''));set(gcf,''UserData'',main_data); cv_reset; ', ...
	          'TooltipString','Sets the order of the filters',...
              'Tag','demo_cv_main_left_frame_edit_para_order_right', ...
              'Style','edit');           

b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
	          'BackgroundColor',[0.95 0.95 0.95], ...   
              'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr  218  dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr) 90], ...
	          'Style','frame', ...
              'Tag','demo_predictor_main_left_frame_order');   
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.normal.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm 280 dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Step sizes:', ...
	          'Tag','demo_cv_main_left_frame_text_control_parameters', ...
              'Style','text');           

b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm  255 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2.1) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.cv(1).mu), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.cv(1).mu  = str2num(get(gco,''String''));set(gcf,''UserData'',main_data); ', ...
	          'TooltipString','Sets the order of the predictor error filters',...
              'Tag','demo_cv_main_left_frame_edit_para_order_right', ...
              'Style','edit');           
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)+5  255 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2.1) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.cv(2).mu), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.cv(2).mu  = str2num(get(gco,''String''));set(gcf,''UserData'',main_data); ', ...
	          'TooltipString','Sets the order of the predictor error filters',...
              'Tag','demo_cv_main_left_frame_edit_para_order_right', ...
              'Style','edit'); 
       
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm  230 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2.1) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.cv(3).mu), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.cv(3).mu  = str2num(get(gco,''String''));set(gcf,''UserData'',main_data); ', ...
	          'TooltipString','Sets the order of the predictor error filters',...
              'Tag','demo_cv_main_left_frame_edit_para_order_right', ...
              'Style','edit');           
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)+5  230 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2.1) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.cv(4).mu), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.cv(4).mu = str2num(get(gco,''String''));set(gcf,''UserData'',main_data); ', ...
	          'TooltipString','Sets the order of the predictor error filters',...
              'Tag','demo_cv_main_left_frame_edit_para_order_right', ...
              'Style','edit');           
   
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
	          'BackgroundColor',[0.95 0.95 0.95], ...   
              'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr  120  dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr) 90], ...
	          'Style','frame', ...
              'Tag','demo_predictor_main_left_frame_order');   
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.normal.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm 180 dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Correlation coefs.:', ...
	          'Tag','demo_cv_main_left_frame_text_control_parameters', ...
              'Style','text');            
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm 155 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Excit.:', ...
	          'Tag','demo_cv_main_left_frame_text_para_order_left', ...
              'Style','text');    
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)+5  155 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2.1) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.signals.cor_coeff_x), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.signals.cor_coeff_x  = str2num(get(gco,''String'')); set(gcf,''UserData'',main_data); if (main_data.signals.cor_coeff_x == 0), set(findobj(gcf,''Tag'',''demo_cv_main_left_frame_text_signals_excitation_right''),''String'',''white noise''); else, set(findobj(gcf,''Tag'',''demo_cv_main_left_frame_text_signals_excitation_right''),''String'',''col. noise''); end; cv_reset; ', ...
	          'TooltipString','Sets the order of the filters',...
              'Tag','demo_cv_main_left_frame_edit_para_order_right', ...
              'Style','edit');  
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[0.95 0.95 0.95], ...   
	          'HorizontalAlignment','left', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr+dim.main_fig.left_frame.space_lr_sm 130 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String','Noise:', ...
	          'Tag','demo_cv_main_left_frame_text_para_order_left', ...
              'Style','text');    
          
b = uicontrol('Parent',a, ...                       
              'Units','pixels', ...              
              'BackgroundColor',[1 1 1], ...   
	          'HorizontalAlignment','right', ...
              'FontWeight','bold', ...
              'FontSize',fonts.small.size, ...
	          'Position',[dim.main_fig.space_lr+round(dim.main_fig.left_frame.width.small/2)+5  130 round((dim.main_fig.left_frame.width.small-(2*dim.main_fig.left_frame.space_lr)-(2*dim.main_fig.left_frame.space_lr_sm))/2.1) dim.main_fig.left_frame.button.height-dim.main_fig.left_frame.button.text_offset], ...
	          'String',num2str(main_data.signals.cor_coeff_n), ...
              'Callback','main_data = get(gcf,''UserData''); main_data.signals.cor_coeff_n  = str2num(get(gco,''String'')); set(gcf,''UserData'',main_data); if (main_data.signals.cor_coeff_n == 0), set(findobj(gcf,''Tag'',''demo_cv_main_left_frame_text_signals_noise_right''),''String'',''white noise''); else, set(findobj(gcf,''Tag'',''demo_cv_main_left_frame_text_signals_noise_right''),''String'',''col. noise''); end; cv_reset; ', ...
	          'TooltipString','Sets the order of the filters',...
              'Tag','demo_cv_main_left_frame_edit_para_order_right', ...
              'Style','edit');          
          
%******************************************************************
% Left frame (hidden)
%******************************************************************              
 
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
         'Visible','off', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ... 
         'CreateFcn','set(gca,''XTick'',[],''YTick'',[]);', ...         
	     'Position',[2*dim.main_fig.space_lr+dim.main_fig.left_frame.width.small  (2*dim.main_fig.space_tb)+dim.main_fig.af_logo.height 1 dim.main_fig.height-(4*dim.main_fig.space_tb)-(2*dim.main_fig.af_logo.height)], ...
	     'Tag','demo_cv_axes_hidden'); 

%******************************************************************
% Main axes (top)
%******************************************************************              
          
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ...     
	     'Position',[300 360 250 200], ...
	     'Tag','demo_cv_axes_top_left');   
     
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ...     
	     'Position',[300 110 250 200], ...
         'Tag','demo_cv_axes_bottom_left');           
 
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ...     
	     'Position',[718 360 250 200], ...
	     'Tag','demo_cv_axes_top_right');   
     
b = axes('Parent',a, ...
         'Units','pixels', ...
	     'Box','on', ...
	     'CameraUpVector',[0 1 0], ...
	     'Color',[1 1 1], ...
         'ColorOrder',mat2, ...     
	     'Position',[718 110 250 200], ...
         'Tag','demo_cv_axes_bottom_right');                      
         
cv_init_plots;

%******************************************************************
% Lower frame
%******************************************************************    
                        
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
	          'BackgroundColor',[0.9 0.9 0.9], ...   
              'Position',[dim.main_fig.space_lr dim.main_fig.space_tb dim.main_fig.width-(2*dim.main_fig.space_lr) dim.main_fig.low_frame.height], ...
	          'Style','frame', ...
              'Tag','demo_cv_lower_frame');           
          
b = uicontrol('Parent',a, ...                        
	          'Units','pixels', ...              
              'Position',[dim.main_fig.width-dim.main_fig.left_frame.space_lr-dim.main_fig.low_frame.button.delta_w-dim.main_fig.low_frame.button.width dim.main_fig.space_tb+round((dim.main_fig.low_frame.height-dim.main_fig.low_frame.button.height)/2) dim.main_fig.low_frame.button.width dim.main_fig.low_frame.button.height], ...  
              'Callback','q_dlg = questdlg(''Do you really want to close the application?'',''Adaptive Filters - Demo Convergence Speed'',''Yes'',''No'',''Cancel'',''Yes''); if strcmp(q_dlg,''Yes''),close(gcf);end;', ...             
	          'String','Close', ...
              'FontWeight','bold', ... 
              'TooltipString','Click here to close the application!',...
              'Tag','demo_cv_button_close');      
                                              
b = uicontrol('Parent',a, ...
	          'Units','pixels', ...
              'Position',[dim.main_fig.space_lr+dim.main_fig.left_frame.space_lr dim.main_fig.space_tb+round((dim.main_fig.low_frame.height-dim.main_fig.low_frame.button.height)/2) dim.main_fig.low_frame.button.width dim.main_fig.low_frame.button.height], ...
              'Callback','main_data = get(gcf,''UserData''); main_data.sim_active = 2; set(gcf,''UserData'',main_data); cv_start_sim;', ...
	          'String','Step', ...
              'FontWeight','bold', ...     
              'TooltipString','',...
              'Tag','demo_cv_button_step');  
          
b = uicontrol('Parent',a, ...
	          'Units','pixels', ...
              'Position',[200 38 dim.main_fig.low_frame.button.width dim.main_fig.low_frame.button.height], ...
              'Callback','main_data = get(gcf,''UserData''); main_data.sim_active = 1; set(gcf,''UserData'',main_data); cv_start_sim;', ...
	          'String','Auto. step', ...
              'FontWeight','bold', ...     
              'TooltipString','',...
              'Tag','demo_cv_button_auto_step');  
          
b = uicontrol('Parent',a, ...
	          'Units','pixels', ...
              'Position',[360 38 dim.main_fig.low_frame.button.width dim.main_fig.low_frame.button.height], ...
              'Callback','main_data = get(gcf,''UserData''); main_data.sim_active = 0; set(gcf,''UserData'',main_data);', ...
	          'String','Stop', ...
              'FontWeight','bold', ...     
              'TooltipString','',...
              'Tag','demo_cv_button_stop');      
          
b = uicontrol('Parent',a, ...
	          'Units','pixels', ...
              'Position',[520 38 dim.main_fig.low_frame.button.width dim.main_fig.low_frame.button.height], ...
              'Callback','cv_reset;', ...
	          'String','Reset', ...
              'FontWeight','bold', ...     
              'TooltipString','',...
              'Tag','demo_cv_button_reset');                 
         
                  
% %******************************************************************
% % Allow resizing of the figure
% %******************************************************************          
%              
% ui_cons = findobj('Parent',a);
% for n = 1:length(ui_cons)
%     set(ui_cons(n),'Units','Normalized');
% end;
%           