function cv_init_plots;

main_data = get(gcf,'UserData');

sim_active_tmp       = main_data.sim_active;
main_data.sim_active = 0;
set(gcf,'UserData',main_data);
drawnow;

if strcmp(main_data.plot_mode,'3D')
    
    %**************************************************************************
    % Plot: top, left
    %**************************************************************************

    set(gcf,'CurrentAxes',findobj('Tag','demo_cv_axes_top_left'));
    cla;
    main_data.cv(1).h_hat     = zeros(1,main_data.signals.N);
    main_data.cv(1).h_hat_old = zeros(1,main_data.signals.N);
    handle_tmp = plot3(main_data.cv(1).h_hat(1),  main_data.cv(1).h_hat(2),  main_data.cv(1).h_hat(3), 'bo', ...
                       main_data.common.h_opt(1), main_data.common.h_opt(2), main_data.common.h_opt(3), 'ro', ...
                       [main_data.cv(1).h_hat(1) main_data.cv(1).h_hat_old(1)], ...
                       [main_data.cv(1).h_hat(2) main_data.cv(1).h_hat_old(2)], ...
                       [main_data.cv(1).h_hat(3) main_data.cv(1).h_hat_old(3)],'k','LineWidth',2);
    main_data.axes(1).handle_h_hat = handle_tmp(1);
    main_data.axes(1).handle_h_opt = handle_tmp(2);
    main_data.axes(1).handle_h_dif = handle_tmp(3);
    set(main_data.axes(1).handle_h_dif,'Color',[1 1 1]*0.4,...
                                       'Marker','o','MarkerEdgeColor','k','MarkerSize',3,'EraseMode','none');
    set(main_data.axes(1).handle_h_hat,'EraseMode','xor');
    grid on;
    box on;
    axis([-1 5 -1 5 -1 5]);
    legend('Adaptive filter','Optimum solution','Location','North');
    set(gca,'Tag','demo_cv_axes_top_left');    
     
    %**************************************************************************
    % Plot: top, right
    %**************************************************************************

    set(gcf,'CurrentAxes',findobj('Tag','demo_cv_axes_top_right'));
    cla;
    main_data.cv(2).h_hat     = zeros(1,main_data.signals.N);
    main_data.cv(2).h_hat_old = zeros(1,main_data.signals.N);
    handle_tmp = plot3(main_data.cv(2).h_hat(1),  main_data.cv(2).h_hat(2),  main_data.cv(2).h_hat(3), 'bo', ...
                       main_data.common.h_opt(1), main_data.common.h_opt(2), main_data.common.h_opt(3), 'ro', ...
                       [main_data.cv(2).h_hat(1) main_data.cv(2).h_hat_old(1)], ...
                       [main_data.cv(2).h_hat(2) main_data.cv(2).h_hat_old(2)], ...
                       [main_data.cv(2).h_hat(3) main_data.cv(2).h_hat_old(3)],'k','LineWidth',2);
    main_data.axes(2).handle_h_hat = handle_tmp(1);
    main_data.axes(2).handle_h_opt = handle_tmp(2);
    main_data.axes(2).handle_h_dif = handle_tmp(3);
    set(main_data.axes(2).handle_h_dif,'Color',[1 1 1]*0.4,...
                                       'Marker','o','MarkerEdgeColor','k','MarkerSize',3,'EraseMode','none');
    set(main_data.axes(2).handle_h_hat,'EraseMode','xor');
    grid on;
    box on;
    axis([-1 5 -1 5 -1 5]);
    legend('Adaptive filter','Optimum solution','Location','North');
    set(gca,'Tag','demo_cv_axes_top_right'); 
    
    %**************************************************************************
    % Plot: bottom, left
    %**************************************************************************

    set(gcf,'CurrentAxes',findobj('Tag','demo_cv_axes_bottom_left'));
    cla;
    main_data.cv(3).h_hat     = zeros(1,main_data.signals.N);
    main_data.cv(3).h_hat_old = zeros(1,main_data.signals.N);
    handle_tmp = plot3(main_data.cv(3).h_hat(1),  main_data.cv(3).h_hat(2),  main_data.cv(3).h_hat(3), 'bo', ...
                       main_data.common.h_opt(1), main_data.common.h_opt(2), main_data.common.h_opt(3), 'ro', ...
                       [main_data.cv(3).h_hat(1) main_data.cv(3).h_hat_old(1)], ...
                       [main_data.cv(3).h_hat(2) main_data.cv(3).h_hat_old(2)], ...
                       [main_data.cv(3).h_hat(3) main_data.cv(3).h_hat_old(3)],'k','LineWidth',2);
    main_data.axes(3).handle_h_hat = handle_tmp(1);
    main_data.axes(3).handle_h_opt = handle_tmp(2);
    main_data.axes(3).handle_h_dif = handle_tmp(3);
    set(main_data.axes(3).handle_h_dif,'Color',[1 1 1]*0.4,...
                                       'Marker','o','MarkerEdgeColor','k','MarkerSize',3,'EraseMode','none');
    set(main_data.axes(3).handle_h_hat,'EraseMode','xor');
    grid on;
    box on;
    axis([-1 5 -1 5 -1 5]);
    legend('Adaptive filter','Optimum solution','Location','North');
    set(gca,'Tag','demo_cv_axes_bottom_left');       
    
    %**************************************************************************
    % Plot: bottom, right
    %**************************************************************************

    set(gcf,'CurrentAxes',findobj('Tag','demo_cv_axes_bottom_right'));
    cla;
    main_data.cv(4).h_hat     = zeros(1,main_data.signals.N);
    main_data.cv(4).h_hat_old = zeros(1,main_data.signals.N);
    handle_tmp = plot3(main_data.cv(4).h_hat(1),  main_data.cv(4).h_hat(2),  main_data.cv(4).h_hat(3), 'bo', ...
                       main_data.common.h_opt(1), main_data.common.h_opt(2), main_data.common.h_opt(3), 'ro', ...
                       [main_data.cv(4).h_hat(1) main_data.cv(4).h_hat_old(1)], ...
                       [main_data.cv(4).h_hat(2) main_data.cv(4).h_hat_old(2)], ...
                       [main_data.cv(4).h_hat(3) main_data.cv(4).h_hat_old(3)],'k','LineWidth',2);
    main_data.axes(4).handle_h_hat = handle_tmp(1);
    main_data.axes(4).handle_h_opt = handle_tmp(2);
    main_data.axes(4).handle_h_dif = handle_tmp(3);
    set(main_data.axes(4).handle_h_dif,'Color',[1 1 1]*0.4,...
                                       'Marker','o','MarkerEdgeColor','k','MarkerSize',3,'EraseMode','none');
    set(main_data.axes(4).handle_h_hat,'EraseMode','xor');
    grid on;
    box on;
    axis([-1 5 -1 5 -1 5]);
    legend('Adaptive filter','Optimum solution','Location','North');
    set(gca,'Tag','demo_cv_axes_bottom_right');   
    
else

    %**************************************************************************
    % Plot: top, left
    %**************************************************************************

    set(gcf,'CurrentAxes',findobj('Tag','demo_cv_axes_top_left'));
    cla;
    main_data.cv(1).h_hat     = zeros(1,main_data.signals.N);
    main_data.cv(1).h_hat_old = zeros(1,main_data.signals.N);
    handle_tmp = plot(main_data.cv(1).h_hat(1),  main_data.cv(1).h_hat(2),  'bo', ...
        main_data.common.h_opt(1), main_data.common.h_opt(2), 'ro', ...
        [main_data.cv(1).h_hat(1) main_data.cv(1).h_hat_old(1)], ...
        [main_data.cv(1).h_hat(2) main_data.cv(1).h_hat_old(2)], 'k', ...
        'LineWidth',2);
    main_data.axes(1).handle_h_hat = handle_tmp(1);
    main_data.axes(1).handle_h_opt = handle_tmp(2);
    main_data.axes(1).handle_h_dif = handle_tmp(3);
    set(main_data.axes(1).handle_h_dif,'Color',[1 1 1]*0.4,...
                                       'Marker','o','MarkerEdgeColor','k','MarkerSize',3,'EraseMode','none');
    set(main_data.axes(1).handle_h_hat,'EraseMode','xor');
    grid on;
    axis([-1 5 -1 5]);
    legend('Adaptive filter','Optimum solution');
    set(gca,'Tag','demo_cv_axes_top_left');

    %**************************************************************************
    % Plot: top, right
    %**************************************************************************

    set(gcf,'CurrentAxes',findobj('Tag','demo_cv_axes_top_right'));
    cla;
    main_data.cv(2).h_hat     = zeros(1,main_data.signals.N);
    main_data.cv(2).h_hat_old = zeros(1,main_data.signals.N);
    handle_tmp = plot(main_data.cv(2).h_hat(1),  main_data.cv(2).h_hat(2),  'bo', ...
        main_data.common.h_opt(1), main_data.common.h_opt(2), 'ro', ...
        [main_data.cv(2).h_hat(1) main_data.cv(2).h_hat_old(1)], ...
        [main_data.cv(2).h_hat(2) main_data.cv(2).h_hat_old(2)], 'k', ...
        'LineWidth',2);
    main_data.axes(2).handle_h_hat = handle_tmp(1);
    main_data.axes(2).handle_h_opt = handle_tmp(2);
    main_data.axes(2).handle_h_dif = handle_tmp(3);
    set(main_data.axes(2).handle_h_dif,'Color',[1 1 1]*0.4,...
                                       'Marker','o','MarkerEdgeColor','k','MarkerSize',3,'EraseMode','none');
    set(main_data.axes(2).handle_h_hat,'EraseMode','xor');
    grid on;
    axis([-1 5 -1 5]);
    legend('Adaptive filter','Optimum solution');
    set(gca,'Tag','demo_cv_axes_top_right');

    %**************************************************************************
    % Plot: bottom, left
    %**************************************************************************

    set(gcf,'CurrentAxes',findobj('Tag','demo_cv_axes_bottom_left'));
    cla;
    main_data.cv(3).h_hat     = zeros(1,main_data.signals.N);
    main_data.cv(3).h_hat_old = zeros(1,main_data.signals.N);
    handle_tmp = plot(main_data.cv(3).h_hat(1),  main_data.cv(3).h_hat(2),  'bo', ...
        main_data.common.h_opt(1), main_data.common.h_opt(2), 'ro', ...
        [main_data.cv(3).h_hat(1) main_data.cv(3).h_hat_old(1)], ...
        [main_data.cv(3).h_hat(2) main_data.cv(3).h_hat_old(2)], 'k', ...
        'LineWidth',2);
    main_data.axes(3).handle_h_hat = handle_tmp(1);
    main_data.axes(3).handle_h_opt = handle_tmp(2);
    main_data.axes(3).handle_h_dif = handle_tmp(3);
    set(main_data.axes(3).handle_h_dif,'Color',[1 1 1]*0.4,...
                                       'Marker','o','MarkerEdgeColor','k','MarkerSize',3,'EraseMode','none');
    set(main_data.axes(3).handle_h_hat,'EraseMode','xor');                                   
    grid on;
    axis([-1 5 -1 5]);
    legend('Adaptive filter','Optimum solution');
    set(gca,'Tag','demo_cv_axes_bottom_left');

    %**************************************************************************
    % Plot: bottom, right
    %**************************************************************************

    set(gcf,'CurrentAxes',findobj('Tag','demo_cv_axes_bottom_right'));
    cla;
    main_data.cv(4).h_hat     = zeros(1,main_data.signals.N);
    main_data.cv(4).h_hat_old = zeros(1,main_data.signals.N);
    handle_tmp = plot(main_data.cv(4).h_hat(1),  main_data.cv(4).h_hat(2),  'bo', ...
        main_data.common.h_opt(1), main_data.common.h_opt(2), 'ro', ...
        [main_data.cv(4).h_hat(1) main_data.cv(4).h_hat_old(1)], ...
        [main_data.cv(4).h_hat(2) main_data.cv(4).h_hat_old(2)], 'k', ...
        'LineWidth',2);
    main_data.axes(4).handle_h_hat = handle_tmp(1);
    main_data.axes(4).handle_h_opt = handle_tmp(2);
    main_data.axes(4).handle_h_dif = handle_tmp(3);
    set(main_data.axes(4).handle_h_dif,'Color',[1 1 1]*0.4,...
                                       'Marker','o','MarkerEdgeColor','k','MarkerSize',3,'EraseMode','none');
    set(main_data.axes(4).handle_h_hat,'EraseMode','xor');
    grid on;
    axis([-1 5 -1 5]);
    legend('Adaptive filter','Optimum solution');
    set(gca,'Tag','demo_cv_axes_bottom_right');

end;

%**************************************************************************
% Save all variables, etc.
%**************************************************************************

main_data.sim_active = sim_active_tmp;
set(gcf,'UserData',main_data);